



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>POJ  3259   Wormholes（SPFA）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">POJ  3259   Wormholes（SPFA）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 03:53:05 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="http://poj.org/problem?id=3259" rel="external nofollow noreferrer">http://poj.org/problem?id=3259</a></p>
<p>题意 ： 农夫约翰农场里发现了很多虫洞，他是个超级冒险迷，想利用虫洞回到过去，看再回来的时候能不能看到没有离开之前的自己，农场里有N块地，M条路连接着两块地，W个虫洞，连接两块地的路是双向的，而虫洞是单向的，去到虫洞之后时间会倒退T秒，如果能遇到离开之前的自己就输出YES，反之就是NO。</p>
<p>样例解释 ：</p>
<p>2</p>
<p>3 3 1</p>
<p>1 2 2</p>
<p>1 3 4</p>
<p>2 3 1</p>
<p>3 1 3</p>
<p>3 2 1</p>
<p>1 2 3</p>
<p>2 3 4</p>
<p>3 1 8</p>
<p>第一行中的2代表有两组测试数据，第一组测试数据中，3,3,1代表着有3块地，3条路，1个虫洞，下面三行代表着编号几到几的权值是几，最后一行代表的是通过虫洞去到目的地时间倒退了t秒</p>
<p>思路 ： 这个题因为去到虫洞时间会倒退，而走农场之间相连的路又会花掉时间，明显是判断有没有负环，只要有负环，他只要一直走就能回到过去，典型的Bellman-Ford做法，本题采用的是spfa做法。</p>
<div>
<div>
<pre class="prettyprint linenums"> #include &lt;cstdio&gt;<br />
 #include &lt;cstring&gt;<br />
 #include &lt;queue&gt;<br />
 #include&lt;iostream&gt;<br />
 using namespace std;

 const int maxn = ;<br />
 const int maxm = ;<br />
 const int oo = &lt;&lt;;<br />
 struct node<br />
 {<br />
     int u;<br />
     int v;<br />
     int w;<br />
     int next;<br />
 } edge[maxm];<br />
 int dis[maxn];<br />
 int cnt;<br />
 int N,M,T;<br />
 int head[maxn];<br />
 bool vis[maxn];<br />
 queue&lt;int&gt;qu;<br />
 int count[maxn];<br />
 void add(int u, int v, int w)<br />
 {<br />
     edge[cnt].u = u;<br />
     edge[cnt].v = v;<br />
     edge[cnt].w = w;<br />
     edge[cnt].next = head[u];<br />
     head[u] = cnt++;<br />
 }

 int spfa(int s)<br />
 {<br />
     memset(count,,sizeof(count));<br />
     for(int i = ; i &lt;= N; i++)<br />
     {<br />
         dis[i] = oo;<br />
         vis[i] = false;<br />
     }<br />
     dis[s] = ;<br />
     qu.push(s);<br />
     vis[s] = true;<br />
     while(!qu.empty())<br />
     {<br />
         int u = qu.front();<br />
         qu.pop();<br />
         vis[u] = false;<br />
         for(int i = head[u]; i != -; i = edge[i].next)<br />
         {<br />
             int v = edge[i].v;<br />
             if(dis[u]+edge[i].w &lt; dis[v])<br />
             {<br />
                 dis[v] = dis[u]+edge[i].w;<br />
                 if(++count[v] &gt; N) return ;<br />
                 if(!vis[v])<br />
                 {<br />
                     vis[v] = true;<br />
                     qu.push(v);<br />
                 }<br />
             }<br />
         }<br />
     }<br />
     return ;<br />
 }

 void init()<br />
 {<br />
     cnt = ;<br />
     memset(head, -, sizeof(head));<br />
 }

 int main()<br />
 {<br />
     int n ;<br />
     scanf("%d",&amp;n);<br />
     while(n--)<br />
     {<br />
         init();<br />
         scanf("%d %d %d",&amp;N,&amp;M,&amp;T);<br />
         int u, v, w;<br />
         for(int i = ; i &lt;= M; i++)<br />
         {<br />
             scanf("%d %d %d", &amp;u, &amp;v, &amp;w);<br />
             add(u, v, w);<br />
             add(v, u, w);<br />
         }<br />
         for(int i =  ; i &lt;= T ; i++)<br />
         {<br />
             cin&gt;&gt;u&gt;&gt;v&gt;&gt;w;<br />
             add(u,v,(-*w));<br />
         }<br />
         int flag = spfa();<br />
         if(flag == )<br />
         cout&lt;&lt;"YES"&lt;&lt;endl;<br />
         else<br />
         cout&lt;&lt;"NO"&lt;&lt;endl;<br />
     }<br />
     return ;<br />
 }</pre>
</div></div>
<p>Bellman-Ford算法及其改进---SPFA算法可以参照下边这个博客</p>
<p><a href="http://hi.baidu.com/laozhonggu/item/30a3f90d81b01fc975cd3c28" rel="external nofollow noreferrer">http://hi.baidu.com/laozhonggu/item/30a3f90d81b01fc975cd3c28</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn1rpx8.html">jQuery学习过程问题笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwl1n39.html">Sunny-ngrok 解决外网访问内网问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mdn568.html">String类的功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyj5zgq.html">Mike的农场 &lpar;BZOJ 4177&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rrjj49.html">BRD</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnkvod8.html">【BZOJ1009】【HNOI2008】GT考试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnre208.html">Java编写的C语言词法分析器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm2pme9.html">struts2整合jfreechart</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjlj0k9.html">QListWidget方式显示缩略图</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kmxl59.html">zzuli求最大值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1dgzxq.html">Android开发按返回键应用后台运行</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjkxog8.html">vue 父组件与子组件的通信</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz4eow8.html">【面试笔试算法】Problem 8&colon; 然而沼跃鱼早就看穿了一切（hiho题库）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyzyee9.html">Python爬虫从入门到进阶&lpar;4&rpar;之xpath的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1z1ymq.html">day07 数据类型间的相互转化及字符编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me157rq.html">gym 101628</a>
		</li>
						<li><a href="https://www.batexi.com/a/950420v8.html">windows下安装mysql数据库修改端口号</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd170z9.html">sourceTree如何不用注册就使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jzy53q.html">LinuxMint 下 B站 番 blv 缓存 转 mp4</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll1rz1q.html">Spring Security（二十一）：6&period;3 Advanced Web Features</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93xn42g9.html">USB接口介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxne7dd8.html">VC 2010下安装OpenCV2&period;4&period;4</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv0geoq.html">rsync参数详解、利用ssh、rsync 实现数据的定时同步</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmke6e9.html">世界级Oracle专家Jonathan Lewis：我很为DBA们的未来担心（图灵访谈）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w2wnoq.html">Oracle 10g下载链接</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmkjwx9.html">【img】 图片是怎么存储的</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z14ox19.html">Swift学习：闭包&lpar;Closures&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w2jowq.html">php中const与define的使用区别 详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z14y3d9.html">0x04 高级语法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvr2yxq.html">对象图 Object Diagram</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
